﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace ConsoleApp1
{
    public static class HelperExtension
    {
        public static unsafe bool TryRead<T>(this BinaryReader br, out T value) where T : unmanaged
        {
            int size = sizeof(T);
            value = default;

            byte[] buf = br.ReadBytes(size);
            if (buf.Length == 0)
            {
                return false;
            }

            GCHandle gcHandle = GCHandle.Alloc(buf, GCHandleType.Pinned);

            try
            {
                value = Marshal.PtrToStructure<T>(gcHandle.AddrOfPinnedObject());
                return true;
            }
            finally
            {
                gcHandle.Free();
            }
        }
    }
}
