﻿using System;
using System.IO;
using System.Threading;

namespace ConsoleApp1
{
    class Program
    {
        static unsafe void Main(string[] args)
        {
            if (Console.IsInputRedirected == false)
            {
                Console.WriteLine("No input redirected");
                return;
            }

            using (BinaryReader br = new BinaryReader(Console.OpenStandardInput(8192)))
            {
                {
                    br.TryRead<pcap_hdr_t>(out pcap_hdr_t header);
                    Console.WriteLine(header.magic_number);
                    Console.WriteLine(header.version_major);
                    Console.WriteLine(header.version_minor);
                    Console.WriteLine(header.thiszone);
                    Console.WriteLine(header.sigfigs);
                    Console.WriteLine(header.snaplen);
                    Console.WriteLine(header.network);
                }

                int index = 1;

                while (true)
                {
                    if (br.TryRead<pcaprec_hdr_t>(out pcaprec_hdr_t record) == false)
                    {
                        break;
                    }

                    int pcapRecordDataSize = (int)record.incl_len;

                    //Console.WriteLine($"[{index}]");
                    //Console.WriteLine(record.ts_sec);
                    //Console.WriteLine(record.ts_usec);
                    //Console.WriteLine(record.incl_len);
                    //Console.WriteLine(record.orig_len);
                    int pcapPacketHeaderSize = sizeof(USBPCAP_BUFFER_PACKET_HEADER);
                    int dataLength = (int)pcapRecordDataSize - pcapPacketHeaderSize;

                    br.TryRead<USBPCAP_BUFFER_PACKET_HEADER>(out USBPCAP_BUFFER_PACKET_HEADER pcapPacket);
                    ReadFunction(index, br, pcapPacket, dataLength);

                    index++;
                }
            }

            Thread.Sleep(1000 * 10);
        }

        private static void ReadFunction(int index, BinaryReader br, USBPCAP_BUFFER_PACKET_HEADER pcapPacket, int dataLength)
        {
            Console.WriteLine($"[{index}]");

            byte[] buf = br.ReadBytes(dataLength);

            switch (pcapPacket.function)
            {
                case URB_FUNCTION.URB_FUNCTION_BULK_OR_INTERRUPT_TRANSFER:
                    if (pcapPacket.Direction == IRPDierction.PDO_TO_FDO)
                    {
                        Console.WriteLine(pcapPacket.Direction + ": " + dataLength);

                        byte code = buf[2];
                        if (code == 0)
                        {
                            Console.WriteLine("key up");
                        }
                        else
                        {
                            // https://gist.github.com/MightyPork/6da26e382a7ad91b5496ee55fdc73db2
                            if (code >= 0x4 && code <= 0x1d)
                            {
                                char ch = (char)(code - 4 + (short)'a');
                                Console.WriteLine(ch + " pressed");
                            }
                            else
                            {
                                Console.WriteLine("Key pressed");
                            }
                        }
                    }
                    break;

                default:
                    break;
            }
        }
    }
}
